auto(1)
local area = {
    {0, 0, 0, 0, 0, 0, 0},
    {0, 0, 0, 2, 0, 0, 0},
    {0, 0, 2, 2, 2, 0, 0},
    {0, 2, 2, 1, 2, 2, 0},
    {0, 0, 2, 2, 2, 0, 0},
    {0, 0, 0, 2, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0}
}

local allCreatures = g_game.getCreatures()
local whitelist = {"Aborygen", "Aragorn", "Galadriela", "Sauron", "Thranduil"}

local monstersWithMostMonstersAround = nil
local mostMonstersAround = -1

for _, creature in ipairs(allCreatures) do
    if not creature:isPlayer() or table.find(whitelist, creature:getName()) then
        local monstersInArea = g_game.getCreaturesInArea(area, false, -1, creature:getPosition())
        local monstersCount = math.max(1, #monstersInArea)
        if monstersCount >= mostMonstersAround then
            monstersWithMostMonstersAround = creature
            mostMonstersAround = monstersCount
        end
    end
end

local attackingCreature = g_game.getAttackingCreature()
if monstersWithMostMonstersAround and (not attackingCreature or monstersWithMostMonstersAround:getId() ~= attackingCreature:getId()) then
    g_game.attack(monstersWithMostMonstersAround)
end

if attackingCreature then
    -- check if there are no players in the area
    local isPlayerInArea = false
    local playersInArea = g_game.getCreaturesInArea(area, false, -1, attackingCreature:getPosition())
    for _, player in ipairs(playersInArea) do
        if not table.find(whitelist, player:getName()) then
            isPlayerInArea = true
            break
        end
    end

    if isPlayerInArea then
        g_game.cancelAttack()
        return
    end
end