FollowThisPerson = "Sauron"

FloorChangers = {
    Ladders = {Up = {1948, 5542}, Down = {432, 412, 469, 8932, 411}},

    Holes = {Up = {0}, Down = {293, 294, 595}},

    RopeSpots = {Up = {386}, Down = {}},

    Stairs = {
        Up = {1956, 1954, 6911, 6913, 22567,1956,1949, 14936, 22566, 22565, 16692, 16694, 14938, 1761,1954,1977,5259,1978, 855, 1958, 7548, 7544, 1952, 1950, 1947, 7542, 8657},
        Down = {6127, 604, 6918, 6919, 23057,859,7067,16267,6130,604,483,4826, 567, 414, 413, 437, 7731, 469, 413, 434, 469, 484}
    },
    Sewers = {Up = {0}, Down = {435}}
}

local walkOptions = {
    useMapClick = false,
    ignoreCreatures = false,
    ignoreNonPathable = false
}

-- Functions
local target = FollowThisPerson
if lastKnownPosition == nil then
    lastKnownPosition = false
end
local player = g_game.getLocalPlayer()
local ropeID = 3003

local function goLastKnown()
    local i = 1
    if not player:getPosition():isInRange(lastKnownPosition, 1, 1) then
        g_game.useMapItem(Position.new(lastKnownPosition.x, lastKnownPosition.y, lastKnownPosition.z))
        sleep(200)
    end
end

local function handleUse(pos)
    goLastKnown()
    local i = 1
    local lastZ = player:getPosition().z
    if player:getPosition().z == lastZ then
        g_game.useMapItem(Position.new(pos.x, pos.y, pos.z))
        sleep(400)
    end
end

local function handleStep(pos)
    goLastKnown()
    local i = 1
    local lastZ = player:getPosition().z
    if player:getPosition().z == lastZ then
        g_game.walkTo(Position.new(pos.x, pos.y, pos.z), walkOptions.ignoreNonPathable, walkOptions.useMapClick, walkOptions.ignoreCreatures)
        sleep(200)
    end
end

local function handleRope(pos)
    goLastKnown()
    local i = 1
    local lastZ = player:getPosition().z
    if player:getPosition().z == lastZ then
        g_game.useInventoryItemOnPosition(ropeId, Position.new(pos.x, pos.y, pos.z))
        sleep(400)
    end
end

local floorChangeSelector = {
    Ladders = {Up = handleUse, Down = handleStep},
    Holes = {Up = handleStep, Down = handleStep},
    RopeSpots = {Up = handleRope, Down = handleRope},
    Stairs = {Up = handleStep, Down = handleStep},
    Sewers = {Up = handleUse, Down = handleUse}
}

local function getPlayerByName(name)
    local creatures = g_game.getCreatures()
    for _, creature in ipairs(creatures) do
        if creature:getName():lower() == name:lower() then
            return creature
        end
    end
end

local function checkTargetPos()
    local c = getPlayerByName(target)
    if c and c:getPosition().z == player:getPosition().z then
        lastKnownPosition = c:getPosition()
    end
end

local function distance(pos1, pos2)
    local pos2 = pos2 or lastKnownPosition or player:getPosition()
    return math.abs(pos1.x - pos2.x) + math.abs(pos1.y - pos2.y)
end

local function executeClosest(possibilities)
    local closest
    local closestDistance = 99999
    for _, data in ipairs(possibilities) do
        local dist = distance(data.pos)
        if dist < closestDistance then
            closest = data
            closestDistance = dist
        end
    end
    if closest then closest.changer(closest.pos) end
end

local function handleFloorChange()
    g_game.cancelFollow()
    local c = getPlayerByName(target)
    local range = 7
    local p = player:getPosition()
    local possibleChangers = {}
    for _, dir in ipairs({"Down", "Up"}) do
        for changer, data in pairs(FloorChangers) do
            for x = -range, range do
                for y = -range, range do
                local tile = g_map.getTile(Position.new(p.x + x, p.y + y, p.z))
                    if tile and tile:getTopItem() and table.find(data[dir],
                                  tile:getTopItem():getId()) then
                        table.insert(possibleChangers, {
                            changer = floorChangeSelector[changer][dir],
                            pos = {x = p.x + x, y = p.y + y, z = p.z}
                        })
                    end
                end
            end
        end
    end
    executeClosest(possibleChangers)
end

local function targetMissing()
    local creatures = g_game.getCreatures()
    for _, creature in ipairs(creatures) do
        if creature:getName():lower() == target:lower() then return creature:getPosition().z ~= player:getPosition().z end
    end

    return true
end

auto(1)
checkTargetPos()
local c = getPlayerByName(target)
if not c or player:getPosition():isInRange(c:getPosition(), 2, 2) then
    setOption("Targeting/Enabled", "true")
else
    setOption("Targeting/Enabled", "false")
    if g_game.getFollowingCreature() ~= c then g_game.follow(c) end
end
if targetMissing() and lastKnownPosition then handleFloorChange() end
